
/*  A Bison parser, made from WMLScriptParserBison.ypp
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED

#define	WHITESPACE	257
#define	LINETERMINATOR	258
#define	LE	259
#define	GE	260
#define	EQ	261
#define	NE	262
#define	AND	263
#define	OR	264
#define	INC	265
#define	DEC	266
#define	SHL	267
#define	SHR	268
#define	SHRR	269
#define	IS	270
#define	MULIS	271
#define	QUOTIS	272
#define	MODIS	273
#define	ADDIS	274
#define	SUBIS	275
#define	SHLIS	276
#define	SHRIS	277
#define	SHRRIS	278
#define	ANDIS	279
#define	XORIS	280
#define	ORIS	281
#define	DIVIS	282
#define	REMAINIS	283
#define	MULTILINENOTASTERISKCHAR	284
#define	MULTILINENOTFORWARDSLASHORASTERISKCHAR	285
#define	SINGLELINECOMMENTCHAR	286
#define	MULTICOMMENT_START	287
#define	MULTICOMMENT_END	288
#define	SINGLECOMMENT	289
#define	IDENTIFIERNAME	290
#define	ACCESS	291
#define	AGENT	292
#define	BREAK	293
#define	CONTINUE	294
#define	DIV	295
#define	HOSTDOMAIN	296
#define	ELSE	297
#define	EQUIV	298
#define	EXTERN	299
#define	FOR	300
#define	FUNCTION	301
#define	HEADER	302
#define	HTTP	303
#define	IF	304
#define	ISVALID	305
#define	META	306
#define	NAME	307
#define	PATH	308
#define	RETURN	309
#define	TYPEOF	310
#define	USE	311
#define	USER	312
#define	VAR	313
#define	WHILE	314
#define	URL	315
#define	DELETE	316
#define	IN	317
#define	LIB	318
#define	NEW	319
#define	NUL	320
#define	THIS	321
#define	VOID	322
#define	WITH	323
#define	CASE	324
#define	CATCH	325
#define	CLASS	326
#define	CONST	327
#define	DEBUGGER	328
#define	DEFAULT	329
#define	DO	330
#define	ENUM	331
#define	EXPORT	332
#define	EXTENDS	333
#define	FINALLY	334
#define	IMPORT	335
#define	PRIVATE	336
#define	PUBLIC	337
#define	SIZEOF	338
#define	STRUCT	339
#define	SUPER	340
#define	SWITCH	341
#define	THROW	342
#define	TRY	343
#define	DECIMALDIGIT	344
#define	DECIMALDIGITS	345
#define	NONZERODIGIT	346
#define	HEXPREFIX	347
#define	HEXDIGIT	348
#define	HEXDIGITS	349
#define	OCTALDIGITS	350
#define	OCTALDIGIT1	351
#define	OCTALDIGIT2	352
#define	OCTALDIGIT3	353
#define	HEXDIGIT2	354
#define	PUNCTUATOR	355
#define	ZEROTOTHREE	356
#define	DECIMALINTEGERLITERAL	357
#define	OCTALINTEGERLITERAL	358
#define	HEXINTEGERLITERAL	359
#define	DECIMALFLOATLITERAL	360
#define	TRUE	361
#define	FALSE	362
#define	INVALID	363
#define	DOUBLESTRINGCHARACTERS	364
#define	SINGLESTRINGCHARACTERS	365
#define	ESCAPESEQUENCE	366
#define	UMINUS	367
#define	UPLUS	368
#define	UINVERT	369
#define	UNOT	370
#define	BITWISEAND	371
#define	BITWISEXOR	372
#define	BITWISEOR	373

#line 1 "WMLScriptParserBison.ypp"

/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: WMLScriptParserBison.ypp,v 1.2 2001/03/11 18:11:42 pascal Exp $
 */

#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <malloc.h>

#include "../lib/Garbage.h"

#define __NO_BISON_TAB_H__
#include "WMLScript.h"

#undef WMLS_DEBUG

#define YYDEBUG 1
#define YYPARSE_PARAM result

/* custom prototypes */
char *dstrcat(WMLScriptParseResult *result, char *s1, char *s2);
nodeType *opr(WMLScriptParseResult *result, int first_line, int first_column, int oper, int nops, ...);
nodeType *id(WMLScriptParseResult *result, int first_line, int first_column, char *s);
nodeType *con(WMLScriptParseResult *result, int first_line, int first_column, char *s, dataType type);
void func(WMLScriptParseResult *result, 
	  nodeType *functionName,
	  nodeType *parameterList,
	  nodeType *functionBody,
	  char flags);
void pragma_external_compilation_unit(WMLScriptParseResult *result, int first_line, int first_column, nodeType *id, nodeType *url);
void pragma_access(WMLScriptParseResult *result, int first_line, int first_column, nodeType *domain, nodeType *path);
void pragma_meta(WMLScriptParseResult *result, int first_line, int first_column, WMLScriptMetaPragmaType metaType, nodeType *metaBody);
int add_pragma(WMLScriptParseResult *result);
int pragma_init(char **d1, char *s1);
void add_garbage(WMLScriptParseResult *result, void *ref);
void dump(nodeType *n, int depth);
extern void add_flex_garbage(WMLScriptParseResult *result, void *ref);
void free_node(nodeType *p);
/* bison prototypes */
void yyerror(char *s);

typedef struct {
  int timestamp;
  int first_line;
  int first_column;
  int last_line;
  int last_column;
  char *text;
} yyltype;

#define YYLTYPE yyltype
#define YYLEX_PARAM ((WMLScriptParseResult *) result)


#line 90 "WMLScriptParserBison.ypp"
typedef union {
  char *stringValue;
  nodeType *nodePtr;
} YYSTYPE;
#line 95 "WMLScriptParserBison.ypp"

extern int yylex(YYSTYPE *lvalp, YYLTYPE *llocp, WMLScriptParseResult *result);

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		324
#define	YYFLAG		-32768
#define	YYNTBASE	149

#define YYTRANSLATE(x) ((unsigned)(x) <= 373 ? yytranslate[x] : 217)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   124,   120,   143,     2,   136,   144,   121,   141,
   142,   134,   116,   115,   117,   114,   135,   113,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   148,   129,   125,
   140,   126,   147,     2,     2,     2,     2,     2,   119,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,   122,     2,   145,     2,     2,     2,     2,     2,     2,
   118,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   127,   146,   128,   123,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   130,   131,   132,   133,
   137,   138,   139
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,    10,    12,    14,    16,    18,
    20,    22,    24,    27,    30,    34,    38,    41,    44,    46,
    48,    51,    54,    56,    58,    60,    62,    66,    68,    70,
    72,    74,    77,    79,    84,    89,    91,    93,    96,   100,
   102,   106,   108,   111,   114,   116,   119,   122,   125,   128,
   131,   134,   137,   140,   142,   146,   150,   154,   158,   160,
   164,   168,   170,   174,   178,   182,   184,   188,   192,   196,
   200,   202,   206,   210,   212,   216,   218,   222,   224,   228,
   230,   234,   236,   240,   242,   248,   250,   254,   258,   262,
   266,   270,   274,   278,   282,   286,   290,   292,   296,   298,
   300,   302,   304,   306,   308,   310,   312,   314,   318,   321,
   323,   326,   330,   332,   336,   339,   341,   344,   346,   349,
   357,   363,   365,   367,   373,   383,   392,   401,   410,   418,
   426,   434,   441,   452,   462,   472,   481,   484,   487,   491,
   494,   503,   511,   519,   526,   534,   541,   548,   554,   556,
   560,   563,   565,   567,   570,   574,   576,   578,   580,   584,
   587,   590,   593,   598,   601,   603,   605,   607,   610,   614,
   618,   622,   625,   627,   629,   631,   633
};

static const short yyrhs[] = {    36,
     0,   151,     0,   152,     0,   153,     0,   154,     0,   109,
     0,   107,     0,   108,     0,   103,     0,   105,     0,   104,
     0,   106,     0,   120,   120,     0,   121,   121,     0,   120,
   155,   120,     0,   121,   156,   121,     0,   110,   155,     0,
   112,   155,     0,   110,     0,   112,     0,   111,   156,     0,
   112,   156,     0,   111,     0,   112,     0,    36,     0,   150,
     0,   141,   181,   142,     0,   157,     0,   159,     0,   161,
     0,   162,     0,   160,   165,     0,   149,     0,   163,   143,
   160,   165,     0,   164,   114,   160,   165,     0,   149,     0,
   149,     0,   141,   142,     0,   141,   166,   142,     0,   180,
     0,   166,   115,   180,     0,   158,     0,    36,    11,     0,
    36,    12,     0,   167,     0,    56,   168,     0,    51,   168,
     0,    11,    36,     0,    12,    36,     0,   116,   168,     0,
   117,   168,     0,   123,   168,     0,   124,   168,     0,   168,
     0,   169,   134,   168,     0,   169,   135,   168,     0,   169,
    41,   168,     0,   169,   136,   168,     0,   169,     0,   170,
   116,   169,     0,   170,   117,   169,     0,   170,     0,   171,
    13,   170,     0,   171,    14,   170,     0,   171,    15,   170,
     0,   171,     0,   172,   125,   171,     0,   172,   126,   171,
     0,   172,     5,   171,     0,   172,     6,   171,     0,   172,
     0,   173,     7,   172,     0,   173,     8,   172,     0,   173,
     0,   174,   144,   173,     0,   174,     0,   175,   145,   174,
     0,   175,     0,   176,   146,   175,     0,   176,     0,   177,
     9,   176,     0,   177,     0,   178,    10,   177,     0,   178,
     0,   178,   147,   180,   148,   180,     0,   179,     0,   149,
   140,   180,     0,    36,    20,   180,     0,    36,    21,   180,
     0,    36,    17,   180,     0,    36,    18,   180,     0,    36,
    29,   180,     0,    36,    28,   180,     0,    36,    22,   180,
     0,    36,    23,   180,     0,    36,    24,   180,     0,   180,
     0,   181,   115,   180,     0,   183,     0,   185,     0,   189,
     0,   190,     0,   191,     0,   192,     0,   195,     0,   196,
     0,   197,     0,   127,   184,   128,     0,   127,   128,     0,
   182,     0,   184,   182,     0,    59,   186,   129,     0,   187,
     0,   186,   115,   187,     0,   149,   188,     0,   149,     0,
   140,   179,     0,   129,     0,   181,   129,     0,    50,   141,
   181,   142,   182,    43,   182,     0,    50,   141,   181,   142,
   182,     0,   193,     0,   194,     0,    60,   141,   181,   142,
   182,     0,    46,   141,   181,   129,   181,   129,   181,   142,
   182,     0,    46,   141,   181,   129,   181,   129,   142,   182,
     0,    46,   141,   181,   129,   129,   181,   142,   182,     0,
    46,   141,   129,   181,   129,   181,   142,   182,     0,    46,
   141,   181,   129,   129,   142,   182,     0,    46,   141,   129,
   181,   129,   142,   182,     0,    46,   141,   129,   129,   181,
   142,   182,     0,    46,   141,   129,   129,   142,   182,     0,
    46,   141,    59,   186,   129,   181,   129,   181,   142,   182,
     0,    46,   141,    59,   186,   129,   181,   129,   142,   182,
     0,    46,   141,    59,   186,   129,   129,   181,   142,   182,
     0,    46,   141,    59,   186,   129,   129,   142,   182,     0,
    40,   129,     0,    39,   129,     0,    55,   181,   129,     0,
    55,   129,     0,    45,    47,   160,   141,   199,   142,   183,
   129,     0,    45,    47,   160,   141,   199,   142,   183,     0,
    45,    47,   160,   141,   142,   183,   129,     0,    45,    47,
   160,   141,   142,   183,     0,    47,   160,   141,   199,   142,
   183,   129,     0,    47,   160,   141,   199,   142,   183,     0,
    47,   160,   141,   142,   183,   129,     0,    47,   160,   141,
   142,   183,     0,   149,     0,   199,   115,   149,     0,   201,
   216,     0,   216,     0,   202,     0,   201,   202,     0,    57,
   203,   129,     0,   204,     0,   205,     0,   207,     0,    61,
   149,   154,     0,    37,   206,     0,    42,   154,     0,    54,
   154,     0,    42,   154,    54,   154,     0,    52,   208,     0,
   209,     0,   210,     0,   211,     0,    53,   212,     0,    49,
    44,   212,     0,    58,    38,   212,     0,   213,   214,   215,
     0,   213,   214,     0,   154,     0,   154,     0,   154,     0,
   198,     0,   216,   198,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   147,   152,   154,   155,   156,   159,   164,   167,   171,   174,
   176,   178,   183,   186,   188,   190,   194,   197,   199,   200,
   203,   206,   208,   209,   212,   215,   216,   220,   223,   225,
   226,   230,   235,   239,   244,   249,   254,   258,   261,   265,
   268,   272,   275,   277,   281,   284,   286,   288,   290,   292,
   294,   296,   298,   302,   305,   307,   309,   311,   315,   318,
   320,   324,   327,   329,   331,   335,   338,   340,   342,   344,
   348,   351,   353,   357,   360,   364,   367,   371,   374,   378,
   381,   385,   388,   392,   395,   399,   402,   404,   406,   408,
   410,   412,   414,   416,   418,   420,   424,   427,   431,   433,
   434,   435,   436,   437,   438,   439,   440,   443,   446,   450,
   453,   457,   462,   464,   468,   471,   475,   480,   485,   490,
   493,   497,   499,   502,   507,   510,   512,   514,   516,   518,
   520,   522,   524,   526,   528,   530,   534,   539,   544,   547,
   551,   554,   556,   558,   560,   562,   564,   566,   570,   572,
   576,   578,   581,   583,   586,   591,   593,   594,   597,   602,
   607,   610,   612,   616,   621,   623,   624,   627,   632,   637,
   642,   645,   649,   653,   657,   661,   663
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","WHITESPACE",
"LINETERMINATOR","LE","GE","EQ","NE","AND","OR","INC","DEC","SHL","SHR","SHRR",
"IS","MULIS","QUOTIS","MODIS","ADDIS","SUBIS","SHLIS","SHRIS","SHRRIS","ANDIS",
"XORIS","ORIS","DIVIS","REMAINIS","MULTILINENOTASTERISKCHAR","MULTILINENOTFORWARDSLASHORASTERISKCHAR",
"SINGLELINECOMMENTCHAR","MULTICOMMENT_START","MULTICOMMENT_END","SINGLECOMMENT",
"IDENTIFIERNAME","ACCESS","AGENT","BREAK","CONTINUE","DIV","HOSTDOMAIN","ELSE",
"EQUIV","EXTERN","FOR","FUNCTION","HEADER","HTTP","IF","ISVALID","META","NAME",
"PATH","RETURN","TYPEOF","USE","USER","VAR","WHILE","URL","DELETE","IN","LIB",
"NEW","NUL","THIS","VOID","WITH","CASE","CATCH","CLASS","CONST","DEBUGGER","DEFAULT",
"DO","ENUM","EXPORT","EXTENDS","FINALLY","IMPORT","PRIVATE","PUBLIC","SIZEOF",
"STRUCT","SUPER","SWITCH","THROW","TRY","DECIMALDIGIT","DECIMALDIGITS","NONZERODIGIT",
"HEXPREFIX","HEXDIGIT","HEXDIGITS","OCTALDIGITS","OCTALDIGIT1","OCTALDIGIT2",
"OCTALDIGIT3","HEXDIGIT2","PUNCTUATOR","ZEROTOTHREE","DECIMALINTEGERLITERAL",
"OCTALINTEGERLITERAL","HEXINTEGERLITERAL","DECIMALFLOATLITERAL","TRUE","FALSE",
"INVALID","DOUBLESTRINGCHARACTERS","SINGLESTRINGCHARACTERS","ESCAPESEQUENCE",
"'0'","'.'","','","'+'","'-'","'e'","'E'","'\\\"'","'\\''","'\\\\'","'~'","'!'",
"'<'","'>'","'{'","'}'","';'","UMINUS","UPLUS","UINVERT","UNOT","'*'","'/'",
"'%'","BITWISEAND","BITWISEXOR","BITWISEOR","'='","'('","')'","'#'","'&'","'^'",
"'|'","'?'","':'","Identifier","Literal","InvalidLiteral","BooleanLiteral","NumericLiteral",
"StringLiteral","DoubleStringCharacters","SingleStringCharacters","PrimaryExpression",
"CallExpression","LocalScriptFunctionCall","FunctionName","ExternalScriptFunctionCall",
"LibraryFunctionCall","ExternalScriptName","LibraryName","Arguments","ArgumentList",
"PostfixExpression","UnaryExpression","MultiplicativeExpression","AdditiveExpression",
"ShiftExpression","RelationalExpression","EqualityExpression","BitwiseANDExpression",
"BitwiseXORExpression","BitwiseORExpression","LogicalANDExpression","LogicalORExpression",
"ConditionalExpression","AssignmentExpression","Expression","Statement","Block",
"StatementList","VariableStatement","VariableDeclarationList","VariableDeclaration",
"VariableInitializer","EmptyStatement","ExpressionStatement","IfStatement","IterationStatement",
"WhileStatement","ForStatement","ContinueStatement","BreakStatement","ReturnStatement",
"FunctionDeclaration","FormalParameterList","CompilationUnit","Pragmas","Pragma",
"PragmaDeclaration","ExternalCompilationUnitPragma","AccessControlPragma","AccessControlSpecifier",
"MetaPragma","MetaSpecifier","MetaName","MetaHttpEquiv","MetaUserAgent","MetaBody",
"MetaPropertyName","MetaContent","MetaScheme","FunctionDeclarations", NULL
};
#endif

static const short yyr1[] = {     0,
   149,   150,   150,   150,   150,   151,   152,   152,   153,   153,
   153,   153,   154,   154,   154,   154,   155,   155,   155,   155,
   156,   156,   156,   156,   157,   157,   157,   158,   158,   158,
   158,   159,   160,   161,   162,   163,   164,   165,   165,   166,
   166,   167,   167,   167,   168,   168,   168,   168,   168,   168,
   168,   168,   168,   169,   169,   169,   169,   169,   170,   170,
   170,   171,   171,   171,   171,   172,   172,   172,   172,   172,
   173,   173,   173,   174,   174,   175,   175,   176,   176,   177,
   177,   178,   178,   179,   179,   180,   180,   180,   180,   180,
   180,   180,   180,   180,   180,   180,   181,   181,   182,   182,
   182,   182,   182,   182,   182,   182,   182,   183,   183,   184,
   184,   185,   186,   186,   187,   187,   188,   189,   190,   191,
   191,   192,   192,   193,   194,   194,   194,   194,   194,   194,
   194,   194,   194,   194,   194,   194,   195,   196,   197,   197,
   198,   198,   198,   198,   198,   198,   198,   198,   199,   199,
   200,   200,   201,   201,   202,   203,   203,   203,   204,   205,
   206,   206,   206,   207,   208,   208,   208,   209,   210,   211,
   212,   212,   213,   214,   215,   216,   216
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     2,     2,     3,     3,     2,     2,     1,     1,
     2,     2,     1,     1,     1,     1,     3,     1,     1,     1,
     1,     2,     1,     4,     4,     1,     1,     2,     3,     1,
     3,     1,     2,     2,     1,     2,     2,     2,     2,     2,
     2,     2,     2,     1,     3,     3,     3,     3,     1,     3,
     3,     1,     3,     3,     3,     1,     3,     3,     3,     3,
     1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
     3,     1,     3,     1,     5,     1,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     3,     2,     1,
     2,     3,     1,     3,     2,     1,     2,     1,     2,     7,
     5,     1,     1,     5,     9,     8,     8,     8,     7,     7,
     7,     6,    10,     9,     9,     8,     2,     2,     3,     2,
     8,     7,     7,     6,     7,     6,     6,     5,     1,     3,
     2,     1,     1,     2,     3,     1,     1,     1,     3,     2,
     2,     2,     4,     2,     1,     1,     1,     2,     3,     3,
     3,     2,     1,     1,     1,     1,     2
};

static const short yydefact[] = {     0,
     0,     0,     0,   176,     0,   153,   152,     0,     1,    33,
     0,     0,     0,     0,     0,   156,   157,   158,   154,   151,
   177,     0,     0,     0,     0,   160,     0,     0,     0,   164,
   165,   166,   167,     0,   155,     0,     0,   149,     0,     0,
     0,   161,   162,     0,   173,   168,     0,     0,   159,     0,
     0,     0,   148,     0,     0,    19,    20,    13,     0,    23,
    24,    14,     0,     0,   169,   174,   172,   170,   144,     0,
     0,     0,    25,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     9,    11,    10,    12,     7,     8,     6,     0,
     0,     0,     0,   109,   118,     0,    33,    26,     2,     3,
     4,     5,    28,    42,    29,     0,    30,    31,     0,     0,
    45,    54,    59,    62,    66,    71,    74,    76,    78,    80,
    82,    84,    86,    97,     0,   110,    99,     0,   100,   101,
   102,   103,   104,   122,   123,   105,   106,   107,   147,   150,
   146,    17,    18,    15,    21,    22,    16,   163,   175,   171,
   143,   142,    48,    49,    43,    44,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   138,   137,     0,     0,    25,
    33,    47,   140,     0,    46,   116,     0,   113,     0,    50,
    51,    52,    53,     0,     0,     0,    32,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   119,   108,   111,   145,   141,    90,    91,    88,    89,
    94,    95,    96,    93,    92,     0,     0,     0,     0,   139,
     0,   115,     0,   112,     0,    27,    87,    38,     0,    40,
     0,     0,    57,    55,    56,    58,    60,    61,    63,    64,
    65,    69,    70,    67,    68,    72,    73,    75,    77,    79,
    81,    83,     0,    98,     0,     0,     0,     0,     0,   117,
   114,     0,     0,    39,    34,    35,     0,     0,     0,     0,
     0,     0,     0,   121,   124,    41,    85,     0,     0,   132,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   131,   130,     0,   129,     0,     0,     0,   120,   136,     0,
     0,     0,   128,   127,   126,     0,   135,   134,     0,   125,
   133,     0,     0,     0
};

static const short yydefgoto[] = {    97,
    98,    99,   100,   101,   102,    59,    63,   103,   104,   105,
   106,   107,   108,   109,   110,   187,   239,   111,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,   126,   127,   128,   129,   177,   178,   232,   130,
   131,   132,   133,   134,   135,   136,   137,   138,     4,    39,
   322,     5,     6,    15,    16,    17,    26,    18,    30,    31,
    32,    33,    46,    47,    67,   150,     7
};

static const short yypact[] = {   109,
    26,    62,    79,-32768,   109,-32768,    30,    62,-32768,-32768,
   -37,    39,   125,    62,   -20,-32768,-32768,-32768,-32768,    30,
-32768,    -7,   -34,     1,     1,-32768,    98,     1,   107,-32768,
-32768,-32768,-32768,     1,-32768,   -31,    35,-32768,  -104,    60,
   122,   101,-32768,     1,-32768,-32768,     1,     1,-32768,    35,
  -100,   503,    40,    62,    35,    69,    69,-32768,    64,   104,
   104,-32768,    61,     1,-32768,-32768,     1,-32768,    92,    35,
   175,   187,    -4,    99,   110,   113,   121,   848,   684,   848,
    62,   124,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   848,
   848,   848,   848,-32768,-32768,   889,   -82,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   154,-32768,-32768,   153,   184,
-32768,-32768,   -10,   119,   162,     4,   238,   155,   156,   157,
   291,    -9,-32768,-32768,   -55,-32768,-32768,   544,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   173,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   185,-32768,-32768,-32768,-32768,   889,   889,   889,   889,
   889,   889,   889,   889,   889,-32768,-32768,    44,   889,    -8,
   -84,-32768,-32768,   -30,-32768,   164,   -14,-32768,   889,-32768,
-32768,-32768,-32768,   -89,   889,   202,-32768,    62,    62,   848,
   848,   848,   848,   848,   848,   848,   848,   848,   848,   848,
   848,   848,   848,   848,   848,   848,   848,   848,   848,   889,
   889,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    62,   725,    -1,   -88,-32768,
   848,-32768,    62,-32768,   -80,-32768,-32768,-32768,   -79,-32768,
   154,   154,-32768,-32768,-32768,-32768,   -10,   -10,   119,   119,
   119,   162,   162,   162,   162,     4,     4,   238,   155,   156,
   157,   291,   165,-32768,    12,   230,    17,   766,   643,-32768,
-32768,   643,   889,-32768,-32768,-32768,   889,   807,   643,   -78,
   261,   304,    28,   277,-32768,-32768,-32768,   350,    29,-32768,
   643,   643,   -76,   643,   -74,   378,   643,   643,   -58,   424,
-32768,-32768,   643,-32768,   643,   643,   -50,-32768,-32768,   643,
   643,   -48,-32768,-32768,-32768,   643,-32768,-32768,   643,-32768,
-32768,   321,   324,-32768
};

static const short yypgoto[] = {    -2,
-32768,-32768,-32768,-32768,   223,   203,   215,-32768,-32768,-32768,
    20,-32768,-32768,-32768,-32768,    47,-32768,-32768,    27,    97,
    82,    83,    90,   123,   126,   120,   133,   136,-32768,   100,
  -114,   -56,   -42,    32,-32768,-32768,   103,   115,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    63,   294,
-32768,-32768,   337,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -15,-32768,-32768,-32768,   344
};


#define	YYLAST		1030


static const short yytable[] = {    10,
   209,     9,   155,   156,     9,    10,   155,   156,   199,   200,
    54,    34,   157,   158,    54,   159,   160,   161,   162,   163,
    38,    11,   174,   164,   165,   211,   211,    22,    65,   -37,
   190,   -37,    68,    38,   211,   273,   211,    55,   211,   184,
   211,    70,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   140,   236,   269,    71,    72,   211,   185,   -36,   211,
   -36,   272,   274,   291,   211,   303,   211,   305,    53,    21,
   237,   240,     8,   212,     1,   171,     2,   171,   176,    73,
    24,    69,    21,   310,   211,   214,   141,   171,   171,   171,
   171,   316,    25,   319,    78,   263,   264,     9,   230,    80,
   233,   152,   226,    23,   172,    -1,   175,    37,    35,    -1,
    50,   228,   229,   211,   234,    12,   180,   181,   182,   183,
    40,    41,   235,   191,   192,   193,   233,   268,   201,   202,
    13,   211,    -1,    36,    -1,    -1,    -1,   210,    -1,    14,
   278,    44,   211,   211,    48,   281,    83,    84,    85,    86,
    87,    88,    89,     1,    64,     2,   296,   300,   286,    90,
    91,    52,   287,    40,    41,     3,    92,    93,   139,    56,
   267,    57,   227,    27,   196,   197,   198,    28,    56,    58,
    57,   147,    29,   144,    96,    10,    10,   171,   171,   171,
   171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
   171,   171,   171,   171,   171,   171,   171,   241,   242,   280,
   153,   283,    71,    72,    60,    61,   243,   244,   245,   246,
   151,   289,   154,   176,   293,   295,   284,   166,   171,   285,
   176,   299,    60,    61,   194,   195,   290,    73,   167,   307,
    71,    72,    62,   312,   203,   204,    42,    43,   301,   302,
    45,   304,    78,   168,   308,   309,    49,    80,   142,   143,
   313,   169,   314,   315,   179,    73,    45,   317,   318,    66,
    45,    71,    72,   320,   145,   146,   321,   249,   250,   251,
    78,   252,   253,   254,   255,    80,   148,   275,   276,   149,
   247,   248,   256,   257,   186,   188,    73,   189,   205,   208,
   206,   215,   207,   231,    83,    84,    85,    86,    87,    88,
    89,    78,   277,   216,    71,    72,    80,    90,    91,   297,
   323,    40,    41,   324,    92,    93,   260,   258,   265,    51,
   270,   259,    83,    84,    85,    86,    87,    88,    89,    73,
   261,    19,    96,   238,   262,    90,    91,   271,    20,    40,
    41,     0,    92,    93,    78,     0,     0,     0,     0,    80,
    71,    72,     0,    83,    84,    85,    86,    87,    88,    89,
    96,   279,     0,     0,     0,     0,    90,    91,     0,     0,
    40,    41,     0,    92,    93,    73,     0,     0,    71,    72,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    78,    96,   292,     0,     0,    80,    83,    84,    85,    86,
    87,    88,    89,    73,     0,     0,     0,     0,     0,    90,
    91,     0,     0,    40,    41,     0,    92,    93,    78,     0,
     0,     0,     0,    80,    71,    72,     0,     0,     0,     0,
     0,     0,     0,     0,    96,   294,     0,     0,     0,     0,
     0,     0,    83,    84,    85,    86,    87,    88,    89,    73,
     0,     0,     0,     0,     0,    90,    91,     0,     0,    40,
    41,     0,    92,    93,    78,     0,     0,     0,     0,    80,
    83,    84,    85,    86,    87,    88,    89,     0,     0,     0,
    96,   298,     0,    90,    91,     0,     0,    40,    41,     0,
    92,    93,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    71,    72,     0,     0,     0,    96,   306,
     0,     0,     0,     0,     0,     0,    83,    84,    85,    86,
    87,    88,    89,     0,     0,     0,     0,     0,    73,    90,
    91,    74,    75,    40,    41,     0,    92,    93,    76,     0,
     0,     0,    77,    78,    71,    72,     0,    79,    80,     0,
     0,    81,    82,     0,    96,   311,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    73,
     0,     0,    74,    75,     0,     0,     0,     0,     0,    76,
     0,     0,     0,    77,    78,     0,     0,     0,    79,    80,
     0,     0,    81,    82,     0,    83,    84,    85,    86,    87,
    88,    89,     0,     0,     0,     0,     0,     0,    90,    91,
     0,     0,    40,    41,     0,    92,    93,     0,     0,    52,
    94,    95,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    96,     0,     0,    83,    84,    85,    86,
    87,    88,    89,    71,    72,     0,     0,     0,     0,    90,
    91,     0,     0,    40,    41,     0,    92,    93,     0,     0,
    52,   213,    95,     0,     0,     0,     0,     0,    73,     0,
     0,    74,    75,     0,    96,     0,     0,     0,    76,     0,
     0,     0,    77,    78,    71,    72,     0,    79,    80,     0,
     0,    81,    82,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    73,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    78,    71,    72,     0,     0,    80,
     0,     0,     0,     0,     0,    83,    84,    85,    86,    87,
    88,    89,     0,     0,     0,     0,     0,     0,    90,    91,
    73,     0,    40,    41,     0,    92,    93,     0,     0,    52,
     0,    95,     0,     0,     0,    78,    71,    72,     0,     0,
    80,     0,     0,    96,     0,     0,    83,    84,    85,    86,
    87,    88,    89,     0,     0,     0,     0,     0,     0,    90,
    91,    73,     0,    40,    41,     0,    92,    93,     0,     0,
     0,     0,   173,     0,     0,     0,    78,    71,    72,     0,
     0,    80,     0,     0,    96,     0,     0,    83,    84,    85,
    86,    87,    88,    89,     0,     0,     0,     0,     0,     0,
    90,    91,    73,     0,    40,    41,     0,    92,    93,     0,
     0,     0,     0,   266,     0,     0,     0,    78,    71,    72,
     0,     0,    80,     0,     0,    96,     0,     0,    83,    84,
    85,    86,    87,    88,    89,     0,     0,     0,     0,     0,
     0,    90,    91,   170,     0,    40,    41,     0,    92,    93,
     0,     0,     0,     0,   282,     0,     0,     0,    78,    71,
    72,     0,     0,    80,     0,     0,    96,     0,     0,    83,
    84,    85,    86,    87,    88,    89,     0,     0,     0,     0,
     0,     0,    90,    91,    73,     0,    40,    41,     0,    92,
    93,     0,     0,     0,     0,   288,     0,     0,     0,    78,
     0,     0,     0,     0,    80,     0,     0,    96,     0,     0,
    83,    84,    85,    86,    87,    88,    89,     0,     0,     0,
     0,     0,     0,    90,    91,     0,     0,    40,    41,     0,
    92,    93,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
     0,    83,    84,    85,    86,    87,    88,    89,     0,     0,
     0,     0,     0,     0,    90,    91,     0,     0,    40,    41,
     0,    92,    93,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    96
};

static const short yycheck[] = {     2,
    10,    36,    11,    12,    36,     8,    11,    12,     5,     6,
   115,    14,    17,    18,   115,    20,    21,    22,    23,    24,
    23,     2,    79,    28,    29,   115,   115,     8,    44,   114,
    41,   114,    48,    36,   115,   115,   115,   142,   115,    96,
   115,   142,   157,   158,   159,   160,   161,   162,   163,   164,
   165,    54,   142,   142,    11,    12,   115,   140,   143,   115,
   143,   142,   142,   142,   115,   142,   115,   142,    37,     7,
   185,   186,    47,   129,    45,    78,    47,    80,    81,    36,
    42,    50,    20,   142,   115,   128,    55,    90,    91,    92,
    93,   142,    54,   142,    51,   210,   211,    36,   129,    56,
   115,    70,    59,   141,    78,   114,    80,   142,   129,   114,
   142,   168,   169,   115,   129,    37,    90,    91,    92,    93,
   120,   121,   179,   134,   135,   136,   115,   129,   125,   126,
    52,   115,   141,   141,   143,   140,   141,   147,   143,    61,
   129,    44,   115,   115,    38,   129,   103,   104,   105,   106,
   107,   108,   109,    45,    54,    47,   129,   129,   273,   116,
   117,   127,   277,   120,   121,    57,   123,   124,   129,   110,
   227,   112,   129,    49,    13,    14,    15,    53,   110,   120,
   112,   121,    58,   120,   141,   188,   189,   190,   191,   192,
   193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
   203,   204,   205,   206,   207,   208,   209,   188,   189,   266,
    36,   268,    11,    12,   111,   112,   190,   191,   192,   193,
   129,   278,    36,   226,   281,   282,   269,   129,   231,   272,
   233,   288,   111,   112,   116,   117,   279,    36,   129,   296,
    11,    12,   121,   300,     7,     8,    24,    25,   291,   292,
    28,   294,    51,   141,   297,   298,    34,    56,    56,    57,
   303,   141,   305,   306,   141,    36,    44,   310,   311,    47,
    48,    11,    12,   316,    60,    61,   319,   196,   197,   198,
    51,   199,   200,   201,   202,    56,    64,   241,   242,    67,
   194,   195,   203,   204,   141,   143,    36,   114,   144,     9,
   145,   129,   146,   140,   103,   104,   105,   106,   107,   108,
   109,    51,   148,   129,    11,    12,    56,   116,   117,    43,
     0,   120,   121,     0,   123,   124,   207,   205,   226,    36,
   231,   206,   103,   104,   105,   106,   107,   108,   109,    36,
   208,     5,   141,   142,   209,   116,   117,   233,     5,   120,
   121,    -1,   123,   124,    51,    -1,    -1,    -1,    -1,    56,
    11,    12,    -1,   103,   104,   105,   106,   107,   108,   109,
   141,   142,    -1,    -1,    -1,    -1,   116,   117,    -1,    -1,
   120,   121,    -1,   123,   124,    36,    -1,    -1,    11,    12,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    51,   141,   142,    -1,    -1,    56,   103,   104,   105,   106,
   107,   108,   109,    36,    -1,    -1,    -1,    -1,    -1,   116,
   117,    -1,    -1,   120,   121,    -1,   123,   124,    51,    -1,
    -1,    -1,    -1,    56,    11,    12,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   141,   142,    -1,    -1,    -1,    -1,
    -1,    -1,   103,   104,   105,   106,   107,   108,   109,    36,
    -1,    -1,    -1,    -1,    -1,   116,   117,    -1,    -1,   120,
   121,    -1,   123,   124,    51,    -1,    -1,    -1,    -1,    56,
   103,   104,   105,   106,   107,   108,   109,    -1,    -1,    -1,
   141,   142,    -1,   116,   117,    -1,    -1,   120,   121,    -1,
   123,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,   141,   142,
    -1,    -1,    -1,    -1,    -1,    -1,   103,   104,   105,   106,
   107,   108,   109,    -1,    -1,    -1,    -1,    -1,    36,   116,
   117,    39,    40,   120,   121,    -1,   123,   124,    46,    -1,
    -1,    -1,    50,    51,    11,    12,    -1,    55,    56,    -1,
    -1,    59,    60,    -1,   141,   142,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
    -1,    -1,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,
    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    55,    56,
    -1,    -1,    59,    60,    -1,   103,   104,   105,   106,   107,
   108,   109,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,
    -1,    -1,   120,   121,    -1,   123,   124,    -1,    -1,   127,
   128,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   141,    -1,    -1,   103,   104,   105,   106,
   107,   108,   109,    11,    12,    -1,    -1,    -1,    -1,   116,
   117,    -1,    -1,   120,   121,    -1,   123,   124,    -1,    -1,
   127,   128,   129,    -1,    -1,    -1,    -1,    -1,    36,    -1,
    -1,    39,    40,    -1,   141,    -1,    -1,    -1,    46,    -1,
    -1,    -1,    50,    51,    11,    12,    -1,    55,    56,    -1,
    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    51,    11,    12,    -1,    -1,    56,
    -1,    -1,    -1,    -1,    -1,   103,   104,   105,   106,   107,
   108,   109,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,
    36,    -1,   120,   121,    -1,   123,   124,    -1,    -1,   127,
    -1,   129,    -1,    -1,    -1,    51,    11,    12,    -1,    -1,
    56,    -1,    -1,   141,    -1,    -1,   103,   104,   105,   106,
   107,   108,   109,    -1,    -1,    -1,    -1,    -1,    -1,   116,
   117,    36,    -1,   120,   121,    -1,   123,   124,    -1,    -1,
    -1,    -1,   129,    -1,    -1,    -1,    51,    11,    12,    -1,
    -1,    56,    -1,    -1,   141,    -1,    -1,   103,   104,   105,
   106,   107,   108,   109,    -1,    -1,    -1,    -1,    -1,    -1,
   116,   117,    36,    -1,   120,   121,    -1,   123,   124,    -1,
    -1,    -1,    -1,   129,    -1,    -1,    -1,    51,    11,    12,
    -1,    -1,    56,    -1,    -1,   141,    -1,    -1,   103,   104,
   105,   106,   107,   108,   109,    -1,    -1,    -1,    -1,    -1,
    -1,   116,   117,    36,    -1,   120,   121,    -1,   123,   124,
    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    51,    11,
    12,    -1,    -1,    56,    -1,    -1,   141,    -1,    -1,   103,
   104,   105,   106,   107,   108,   109,    -1,    -1,    -1,    -1,
    -1,    -1,   116,   117,    36,    -1,   120,   121,    -1,   123,
   124,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    51,
    -1,    -1,    -1,    -1,    56,    -1,    -1,   141,    -1,    -1,
   103,   104,   105,   106,   107,   108,   109,    -1,    -1,    -1,
    -1,    -1,    -1,   116,   117,    -1,    -1,   120,   121,    -1,
   123,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,
    -1,   103,   104,   105,   106,   107,   108,   109,    -1,    -1,
    -1,    -1,    -1,    -1,   116,   117,    -1,    -1,   120,   121,
    -1,   123,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 149 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue); ;
    break;}
case 6:
#line 161 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, NULL, dataInvalid); ;
    break;}
case 7:
#line 166 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue, dataBool); ;
    break;}
case 8:
#line 168 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue, dataBool); ;
    break;}
case 9:
#line 173 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue, dataInt); ;
    break;}
case 10:
#line 175 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue, dataInt); ;
    break;}
case 11:
#line 177 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue, dataInt); ;
    break;}
case 12:
#line 179 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue, dataFloat); ;
    break;}
case 13:
#line 185 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, "", dataString); ;
    break;}
case 14:
#line 187 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, "", dataString); ;
    break;}
case 15:
#line 189 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, yyvsp[-1].stringValue, dataString); ;
    break;}
case 16:
#line 191 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = con((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, yyvsp[-1].stringValue, dataString); ;
    break;}
case 17:
#line 196 "WMLScriptParserBison.ypp"
{ yyval.stringValue = dstrcat((WMLScriptParseResult *) result, yyvsp[-1].stringValue, yyvsp[0].stringValue); ;
    break;}
case 18:
#line 198 "WMLScriptParserBison.ypp"
{ yyval.stringValue = dstrcat((WMLScriptParseResult *) result, yyvsp[-1].stringValue, yyvsp[0].stringValue); ;
    break;}
case 21:
#line 205 "WMLScriptParserBison.ypp"
{ yyval.stringValue = dstrcat((WMLScriptParseResult *) result, yyvsp[-1].stringValue, yyvsp[0].stringValue); ;
    break;}
case 22:
#line 207 "WMLScriptParserBison.ypp"
{ yyval.stringValue = dstrcat((WMLScriptParseResult *) result, yyvsp[-1].stringValue, yyvsp[0].stringValue); ;
    break;}
case 25:
#line 214 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue); ;
    break;}
case 27:
#line 217 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = yyvsp[-1].nodePtr; ;
    break;}
case 28:
#line 222 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 29:
#line 224 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 31:
#line 227 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 32:
#line 232 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, LOCALSCRIPTFUNCTIONCALL, 2, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 34:
#line 241 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-3].first_line, yylsp[-3].first_column, 44, 3, yyvsp[-3].nodePtr, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 35:
#line 246 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-3].first_line, yylsp[-3].first_column, LIBRARYSCRIPTFUNCTIONCALL, 3, yyvsp[-3].nodePtr, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 36:
#line 251 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, 46, 1, yyvsp[0].nodePtr); ;
    break;}
case 38:
#line 260 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, ARGUMENTS, 0); ;
    break;}
case 39:
#line 262 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ARGUMENTS, 1, yyvsp[-1].nodePtr); ;
    break;}
case 40:
#line 267 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, ARGUMENTLIST, 1, yyvsp[0].nodePtr); ;
    break;}
case 41:
#line 269 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ARGUMENTLIST, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 42:
#line 274 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 43:
#line 276 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, POSTFIXEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, yyvsp[-1].stringValue), opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, '+', 2, id((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, yyvsp[-1].stringValue), con((WMLScriptParseResult *) result, 0, 0, "1", dataInt))); ;
    break;}
case 44:
#line 278 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, POSTFIXEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue), opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, '-', 2, id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue), con((WMLScriptParseResult *) result, 0, 0, "1", dataInt))); ;
    break;}
case 45:
#line 283 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 46:
#line 285 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, TYPEOF, 1, yyvsp[0].nodePtr); ;
    break;}
case 47:
#line 287 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, ISVALID, 1, yyvsp[0].nodePtr); ;
    break;}
case 48:
#line 289 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue), opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, '+', 2, id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue), con((WMLScriptParseResult *) result, 0, 0, "1", dataInt))); ;
    break;}
case 49:
#line 291 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue), opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, '-', 2, id((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, yyvsp[0].stringValue), con((WMLScriptParseResult *) result, 0, 0, "1", dataInt))); ;
    break;}
case 50:
#line 293 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, UPLUS, 1, yyvsp[0].nodePtr); ;
    break;}
case 51:
#line 295 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, UMINUS, 1, yyvsp[0].nodePtr); ;
    break;}
case 52:
#line 297 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, UINVERT, 1, yyvsp[0].nodePtr); ;
    break;}
case 53:
#line 299 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, UNOT, 1, yyvsp[0].nodePtr); ;
    break;}
case 54:
#line 304 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 55:
#line 306 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '*', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 56:
#line 308 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '/', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 57:
#line 310 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, DIV, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 58:
#line 312 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '%', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 59:
#line 317 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 60:
#line 319 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '+', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 61:
#line 321 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '-', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 62:
#line 326 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 63:
#line 328 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, SHL, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 64:
#line 330 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, SHR, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 65:
#line 332 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, SHRR, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 66:
#line 337 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 67:
#line 339 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '<', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 68:
#line 341 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '>', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 69:
#line 343 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, LE, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 70:
#line 345 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, GE, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 71:
#line 350 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 72:
#line 352 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, EQ, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 73:
#line 354 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, NE, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 74:
#line 359 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 75:
#line 361 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '&', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 76:
#line 366 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 77:
#line 368 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '^', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 78:
#line 373 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 79:
#line 375 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '|', 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 80:
#line 380 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 81:
#line 382 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, AND, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 82:
#line 387 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 83:
#line 389 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, OR, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 84:
#line 394 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 85:
#line 396 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-4].first_line, yylsp[-4].first_column, IF, 3, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 86:
#line 401 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 87:
#line 403 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 88:
#line 405 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '+', 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 89:
#line 407 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '-', 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 90:
#line 409 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '*', 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 91:
#line 411 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '/', 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 92:
#line 413 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, '%', 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 93:
#line 415 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, DIV, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 94:
#line 417 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, SHL, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 95:
#line 419 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, SHR, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 96:
#line 421 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, ASSIGNMENTEXPRESSION, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, SHRR, 2, id((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-2].stringValue), yyvsp[0].nodePtr)); ;
    break;}
case 97:
#line 426 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, EXPRESSION, 1, yyvsp[0].nodePtr); ;
    break;}
case 98:
#line 428 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, EXPRESSION, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 108:
#line 445 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, STATEMENTLIST, 1, yyvsp[-1].nodePtr); ;
    break;}
case 109:
#line 447 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, STATEMENTLIST, 0); ;
    break;}
case 110:
#line 452 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, STATEMENT, 1, yyvsp[0].nodePtr); ;
    break;}
case 111:
#line 454 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, STATEMENTLIST, 2, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 112:
#line 459 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, VAR, 1, yyvsp[-1].nodePtr); ;
    break;}
case 114:
#line 465 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, VARDECLLIST, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 115:
#line 470 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, VARDECL, 2, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 116:
#line 472 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, VARDECL, 1, yyvsp[0].nodePtr); ;
    break;}
case 117:
#line 477 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, EXPRESSIONSTATEMENT, 1, yyvsp[0].nodePtr); ;
    break;}
case 118:
#line 482 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[0].first_line, yylsp[0].first_column, STATEMENTLIST, 0); ;
    break;}
case 119:
#line 487 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, EXPRESSIONSTATEMENT, 1, yyvsp[-1].nodePtr); ;
    break;}
case 120:
#line 492 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-6].first_line, yylsp[-6].first_column, IF, 3, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 121:
#line 494 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-4].first_line, yylsp[-4].first_column, IF, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 124:
#line 504 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-4].first_line, yylsp[-4].first_column, WHILE, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 125:
#line 509 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-8].first_line, yylsp[-8].first_column, FOR, 4, yyvsp[-6].nodePtr, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 126:
#line 511 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-7].first_line, yylsp[-7].first_column, FOR, 4, yyvsp[-5].nodePtr, yyvsp[-3].nodePtr, NULL, yyvsp[0].nodePtr); ;
    break;}
case 127:
#line 513 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-7].first_line, yylsp[-7].first_column, FOR, 4, yyvsp[-5].nodePtr, NULL, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 128:
#line 515 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-7].first_line, yylsp[-7].first_column, FOR, 4, NULL, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 129:
#line 517 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-6].first_line, yylsp[-6].first_column, FOR, 4, yyvsp[-4].nodePtr, NULL, NULL, yyvsp[0].nodePtr); ;
    break;}
case 130:
#line 519 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-6].first_line, yylsp[-6].first_column, FOR, 4, NULL, yyvsp[-3].nodePtr, NULL, yyvsp[0].nodePtr); ;
    break;}
case 131:
#line 521 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-6].first_line, yylsp[-6].first_column, FOR, 4, NULL, NULL, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 132:
#line 523 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-5].first_line, yylsp[-5].first_column, FOR, 4, NULL, NULL, NULL, yyvsp[0].nodePtr); ;
    break;}
case 133:
#line 525 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-9].first_line, yylsp[-9].first_column, FOR, 4, yyvsp[-6].nodePtr, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 134:
#line 527 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-8].first_line, yylsp[-8].first_column, FOR, 4, yyvsp[-5].nodePtr, yyvsp[-3].nodePtr, NULL, yyvsp[0].nodePtr); ;
    break;}
case 135:
#line 529 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-8].first_line, yylsp[-8].first_column, FOR, 4, yyvsp[-5].nodePtr, NULL, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 136:
#line 531 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-7].first_line, yylsp[-7].first_column, FOR, 4, yyvsp[-4].nodePtr, NULL, NULL, yyvsp[0].nodePtr); ;
    break;}
case 137:
#line 536 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, CONTINUE, 0); ;
    break;}
case 138:
#line 541 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, BREAK, 0); ;
    break;}
case 139:
#line 546 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, RETURN, 1, yyvsp[-1].nodePtr); ;
    break;}
case 140:
#line 548 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, RETURN, 0); ;
    break;}
case 141:
#line 553 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-5].nodePtr, yyvsp[-3].nodePtr, yyvsp[-1].nodePtr, FUNC_EXTERN); ;
    break;}
case 142:
#line 555 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr, FUNC_EXTERN); ;
    break;}
case 143:
#line 557 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-4].nodePtr, NULL, yyvsp[-1].nodePtr, FUNC_EXTERN); ;
    break;}
case 144:
#line 559 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-3].nodePtr, NULL, yyvsp[0].nodePtr, FUNC_EXTERN); ;
    break;}
case 145:
#line 561 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-5].nodePtr, yyvsp[-3].nodePtr, yyvsp[-1].nodePtr, 0); ;
    break;}
case 146:
#line 563 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-4].nodePtr, yyvsp[-2].nodePtr, yyvsp[0].nodePtr, 0); ;
    break;}
case 147:
#line 565 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-4].nodePtr, NULL, yyvsp[-1].nodePtr, 0); ;
    break;}
case 148:
#line 567 "WMLScriptParserBison.ypp"
{ func((WMLScriptParseResult *) result, yyvsp[-3].nodePtr, NULL, yyvsp[0].nodePtr, FUNC_EXTERN); ;
    break;}
case 150:
#line 573 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, FORMALPARAMETERLIST, 2, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 155:
#line 588 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = yyvsp[-1].nodePtr; ;
    break;}
case 159:
#line 599 "WMLScriptParserBison.ypp"
{ pragma_external_compilation_unit((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 160:
#line 604 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = yyvsp[0].nodePtr; ;
    break;}
case 161:
#line 609 "WMLScriptParserBison.ypp"
{ pragma_access((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, yyvsp[0].nodePtr, NULL); ;
    break;}
case 162:
#line 611 "WMLScriptParserBison.ypp"
{ pragma_access((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, NULL, yyvsp[0].nodePtr); ;
    break;}
case 163:
#line 613 "WMLScriptParserBison.ypp"
{ pragma_access((WMLScriptParseResult *) result, yylsp[-3].first_line, yylsp[-3].first_column, yyvsp[-2].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 164:
#line 618 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = yyvsp[0].nodePtr; ;
    break;}
case 168:
#line 629 "WMLScriptParserBison.ypp"
{ pragma_meta((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, typeName, yyvsp[0].nodePtr); ;
    break;}
case 169:
#line 634 "WMLScriptParserBison.ypp"
{ pragma_meta((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, typeHTTPEquiv, yyvsp[0].nodePtr); ;
    break;}
case 170:
#line 639 "WMLScriptParserBison.ypp"
{ pragma_meta((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, typeUserAgent, yyvsp[0].nodePtr); ;
    break;}
case 171:
#line 644 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-2].first_line, yylsp[-2].first_column, METABODY, 3, yyvsp[-2].nodePtr, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
case 172:
#line 646 "WMLScriptParserBison.ypp"
{ yyval.nodePtr = opr((WMLScriptParseResult *) result, yylsp[-1].first_line, yylsp[-1].first_column, METABODY, 2, yyvsp[-1].nodePtr, yyvsp[0].nodePtr); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 666 "WMLScriptParserBison.ypp"


/**
 * Like strcat, concatenates two strings and returns the result,
 * but also marks the result for future garbage collection.
 * @param result pointer to WMLScriptParseResult which tracks garbage.
 * @param s1 the first string.
 * @param s2 the second string.
 * @return the concatenation of strings 1 and 2.
 */
char *dstrcat(WMLScriptParseResult *result, char *s1, char *s2) {
  char *sr = (char *) malloc(strlen(s1) + strlen(s2) + 1);
  if(!sr)
    yyerror("out of memory");

  strcpy(sr, s1);
  strcat(sr, s2);

  add_flex_garbage(result, sr);

  return sr;
}

/**
 * Bison error-reporting function.
 * @param s string describing error condition.
 */
void yyerror(char *s) {
  
  //  fprintf(stdout, "%s\n", s);
}

/**
 * Creates and returns a parse tree node for a constant.
 * @param result pointer at WMLScriptParseResult.
 * @param value the constant value.
 * @param the constant type.
 * @return pointer at new parse tree node.
 */
nodeType *con(WMLScriptParseResult *result, int first_line, int first_column, char *value, dataType type) {
  nodeType *p;
  size_t size = sizeof(WMLScriptValue);

  if(type == dataString)
    size += strlen(value) + 1;

  p = (nodeType *) malloc(sizeof(conNodeType) + size);
  if(!p) 
    yyerror("out of memory");

  p->type = typeCon;
  p->con.value.type = type;
  p->con.location.first_line = first_line;
  p->con.location.first_column = first_column;

#ifdef WMLS_DEBUG
  printf("<<con: type = %d, value = %s>>\n", type, value);
#endif

  switch(type) {
  case dataBool:
    p->con.value.value.boolValue = (strcmp(value, "true") == 0 ? 1 : 0);
    break;
  case dataInt:
    /* check for hexadecimal and octal numbers */
    if(value[1] != '\0') {

      if(value[0] == '0' && (value[1] == 'x' || value[1] == 'X')) {
	
	p->con.value.value.intValue = strtol(value, NULL, 16);
	
      } else if(value[0] == '0') {
	
	p->con.value.value.intValue = strtol(value, NULL, 8);
	
      } else {
      
	p->con.value.value.intValue = atoi(value);
	
      }
    
    } else {

      	p->con.value.value.intValue = atoi(value);

    }

    break;
  case dataFloat:
    p->con.value.value.floatValue = strtod(value, NULL);
    break;
  case dataString:
    strcpy(p->con.value.value.stringValue, value);
    break;
  case dataInvalid:
    break;
  }

  add_garbage(result, p);

  return p;
}

/**
 * Creates and returns a parse tree node for an identifier.
 * @param result pointer at WMLScriptParseResult.
 * @param name the identifier name.
 * @return pointer at new parse tree node.
 */
nodeType *id(WMLScriptParseResult *result, int first_line, int first_column, char *name) {
  nodeType *p;

#ifdef WMLS_DEBUG
  printf("<<id: name = %s (malloc = %d)>>\n", name, sizeof(idNodeType) + strlen(name) + 1);
#endif

  /* allocate node */
  p = (nodeType *) malloc(sizeof(idNodeType) + strlen(name) + 1);

  if(!p) 
    yyerror("out of memory");

  /* copy information */
  p->type = typeId;
  p->id.location.first_line = first_line;
  p->id.location.first_column = first_column;
  strcpy(p->id.name, name);

  add_garbage(result, p);

  return p;
}

/**
 * Creates and returns a parse tree node for an operator.
 * @param result pointer at WMLScriptParseResult.
 * @param oper the opcode.
 * @param nops the number of operands.
 * @param a variable list of operands (themselves parse tree nodes).
 * @return pointer at new parse tree node.
 */
nodeType *opr(WMLScriptParseResult *result, int first_line, int first_column, int oper, int nops, ...) {
  va_list ap;
  nodeType *p;
  size_t size;
  int i;

#ifdef WMLS_DEBUG
  printf("opr: oper = %d\n", oper);
#endif

  /* allocate node */
  size = sizeof(oprNodeType) + (nops - 1) * sizeof(nodeType*);
  p = (nodeType *) malloc(size);

  if(!p)
    yyerror("out of memory");

  /* copy information */
  p->type = typeOpr;
  p->opr.location.first_line = first_line;
  p->opr.location.first_column = first_column;
  p->opr.oper = oper;
  p->opr.nops = nops;
  va_start(ap, nops);
  for (i = 0; i < nops; i++)
    p->opr.op[i] = va_arg(ap, nodeType*);
  va_end(ap);

  add_garbage(result, p);

  return p;
}

/**
 * Constructs an entry in the function table.
 * @param result pointer at WMLScriptParseResult containing the
 * function table.
 * @param functionName the name of the function as id node.
 * @param parameterList the parameter list as parse tree (or NULL).
 * @param functionBody the function body as a parse tree.
 * @param flags function flags.
 */
void func(WMLScriptParseResult *result, 
	  nodeType *functionName,
	  nodeType *parameterList,
	  nodeType *functionBody,
	  char flags) {

  assert(functionName->type == typeId);
  assert(parameterList == NULL || parameterList->type == typeId || parameterList->type == typeOpr);
  assert(functionBody->type == typeOpr);

  nodeType *prev_vp;
  char *varName;

#ifdef WMLS_DEBUG
  printf("func: name = %s\n", functionName->id.name);
#endif
  
  result->numberOfFunctions++;
  result->functionTable = 
    (WMLScriptFunction *) realloc(result->functionTable, 
				  (sizeof(WMLScriptFunction) *
				   (result->numberOfFunctions)));

  if(!result->functionTable)
    yyerror("out of memory");
  
  /* set up function table elements */
  result->functionTable[result->numberOfFunctions - 1].name = functionName;
  result->functionTable[result->numberOfFunctions - 1].flags = flags;
  result->functionTable[result->numberOfFunctions - 1].parseTree = functionBody;
  result->functionTable[result->numberOfFunctions - 1].varPool = CreateVarPool();
  VarPool *varPool = result->functionTable[result->numberOfFunctions - 1].varPool;

  /* create a variable pool from the parse tree */
  nodeType *vp2 = parameterList;

  while(vp2) {

    switch(vp2->type) {
    case typeId:
      /* leaf node */
      varName = vp2->id.name;

#ifdef WMLS_DEBUG
      printf("func: parameter: %s\n", varName);
#endif

      CreateVar(varPool, varName);
      SetVarValue(varPool, varName, NULL);
      /* we're done */
      free(vp2);
      vp2 = NULL;
      break;
      
    case typeOpr:
      /* branch node */
      assert(vp2->opr.oper == FORMALPARAMETERLIST);

      varName = vp2->opr.op[1]->id.name;

#ifdef WMLS_DEBUG
      printf("func: parameter: %s\n", varName);
#endif

      CreateVar(varPool, varName);
      SetVarValue(varPool, varName, NULL);
      /* go to next node */
      free(vp2->opr.op[1]);
      prev_vp = vp2;
      vp2 = vp2->opr.op[0];
      free(prev_vp);
      break;
    default:
      /* shut up warnings about not handling typeCon */
      break;
      
    }

  }

}

void pragma_external_compilation_unit(WMLScriptParseResult* result, int first_line, int first_column, nodeType *id, nodeType *url) {
  assert(id->type == typeId);
  assert(url->type == typeCon);

  if(!add_pragma(result))
    yyerror("out of memory");

  WMLScriptPragma *pragma;
  pragma = (WMLScriptPragma *) malloc(sizeof(WMLScriptExternalCompilationUnitPragma));
  pragma->type = typeExternalCompilationUnit;

  if(!pragma_init(&pragma->ext.id, id->id.name))
    yyerror("out of memory");

  if(!pragma_init(&pragma->ext.url, url->con.value.value.stringValue))
    yyerror("out of memory");

  result->pragmaTable[result->numberOfPragmas - 1] = pragma;

  free_node(id);
  free_node(url);
}

void pragma_access(WMLScriptParseResult* result, int first_line, int first_column, nodeType *domain, nodeType *path) {
  assert(path != NULL || domain != NULL);
  if(domain)
    assert(domain->type == typeCon);
  if(path)
    assert(path->type == typeCon);

  if(!add_pragma(result))
    yyerror("out of memory");

  WMLScriptPragma *pragma;
  pragma = (WMLScriptPragma *) malloc(sizeof(WMLScriptAccessPragma));
  pragma->type = typeAccess;

  if(domain) {

    if(!pragma_init(&pragma->access.domain, domain->con.value.value.stringValue)) 
      yyerror("out of memory");

  } else {

    pragma->access.domain = NULL;

  }
  
  if(path) {

    if(!pragma_init(&pragma->access.path, path->con.value.value.stringValue))
      yyerror("out of memory");

  } else {
    
    pragma->access.path = NULL;

  }

  result->pragmaTable[result->numberOfPragmas - 1] = pragma;

  if(domain) 
    free_node(domain);
  if(path)
    free_node(path);
}

void pragma_meta(WMLScriptParseResult* result, int first_line, int first_column, WMLScriptMetaPragmaType metaType, nodeType *metaBody) {
  assert(metaBody->type == typeOpr);
  assert(metaBody->opr.nops == 2 || metaBody->opr.nops == 3);

  if(!add_pragma(result))
    yyerror("out of memory");

  WMLScriptPragma *pragma;
  pragma = (WMLScriptPragma *) malloc(sizeof(WMLScriptMetaPragma));
  pragma->type = typeMeta;
  pragma->meta.metaType = metaType;

  nodeType *key = metaBody->opr.op[0];
  assert(key->type == typeCon);

  if(!pragma_init(&pragma->meta.key, key->con.value.value.stringValue)) 
    yyerror("out of memory");

  nodeType *value = metaBody->opr.op[1];
  assert(value->type == typeCon);

  if(!pragma_init(&pragma->meta.value, value->con.value.value.stringValue))
    yyerror("out of memory");

  if(metaBody->opr.nops == 3) {
    
    nodeType *scheme = metaBody->opr.op[2];
    assert(scheme->type == typeCon);

    if(!pragma_init(&pragma->meta.scheme, scheme->con.value.value.stringValue))
      yyerror("out of memory");

  } else {

    pragma->meta.scheme = NULL;

  }

  result->pragmaTable[result->numberOfPragmas - 1] = pragma;

  free_node(metaBody);
}

int add_pragma(WMLScriptParseResult *result) {
  result->numberOfPragmas++;
  result->pragmaTable = (WMLScriptPragma **) realloc(result->pragmaTable,
						    sizeof(WMLScriptPragma *) * 
						    result->numberOfPragmas);

  if(!result->pragmaTable)
    return 0;

  return 1;
}

int pragma_init(char **d1, char *s1) {
  if(s1) {

    *d1 = (char *) malloc(strlen(s1) + 1);

    if(!*d1)
      return 0;
    
    strcpy(*d1, s1);

  }

  return 1;

}

/**
 * Remembers a pointer for possible future garbage collection.
 * @param result pointer to a WMLScriptParseResult.
 * @param ref pointer to remember.
 */
void add_garbage(WMLScriptParseResult *result, void *ref) {

  GarbageAdd(&(result->conditionalGarbage), ref);

}


void free_node(nodeType *p) {
  int i;

  if (!p) return;
  if (p->type == typeOpr) {
    for (i = 0; i < p->opr.nops; i++)
      free_node(p->opr.op[i]);
  }

  free (p);
}
